/*
 *	main.c
 *
 *	X^[XC[vǂ
 *
 *	* Wed Sep 22 19:00:00 JST 2004 Naoyuki Sawa
 *	- 1st[XB
 */
#include "app.h"

/****************************************************************************
 *	
 ****************************************************************************/

#ifdef USE_MUSIC
#include "instdef2.c"
#endif /*USE_MUSIC*/

#ifdef USE_SPRITE
#define SPRITE_ SPRITE_INIT2
const SPRITE sprite_table[SPRITE_COUNT] = {
#include "sprite.h"
};
#undef SPRITE_
#endif /*USE_SPRITE*/

#define extern
#include "work.h"
#undef extern

/****************************************************************************
 *	main
 ****************************************************************************/

int
main()
{
	/* B */
	app_init();

	/* nCXRAlݒB */
	hiscore = 100000;

	/* ՓxIlݒB */
	color_num = 3;	/* 1`3A^CgʂɂĕύX\ */
	boss_life = 5;	/* 3`7A^CgʂɂĕύX\ */
	line_rate = 5;	/* 0`100A܂̂ƂŒ */
	star_rate = 25;	/* 0`100A܂̂ƂŒ */

	/* C[vB */
	for(;;) {
		if(demo_main() < 0) break;
		game_main();
	}

	return 0;
}

/****************************************************************************
 *	app_init
 ****************************************************************************/

void
app_init()
{
	/* ʓIȏB */
	pceLCDDispStop();
#ifdef V_SCREEN
	pceLCDSetBuffer(_def_vbuff);
#else /*V_SCREEN*/
	pceLCDSetBuffer(vbuff);
#endif /*V_SCREEN*/
	pceAppSetProcPeriod(1000 / FPS);
	pcePadSetTrigMode(PP_MODE_SINGLE);
	pceLCDDispStart();

	/* `B */
	surface.w = DISP_X;
	surface.h = DISP_Y;
	surface.vbuff = vbuff;
	render_init_2d(&render, &surface, 0, 0, 0, 0);

#if defined(TRACE_ON) && (TRACE_ON)
	/* WG[o͂J܂B */
	stderr_open(1/*WG[o̓j^ڑ҂()*/);
#endif /*TRACE_ON*/

#ifdef TURBO
	/* NbNEEFCgؑւ܂B */
	turbo(TURBO);
#endif /*TURBO*/

#ifdef USE_GC
	/* K[x[WRN^[܂B */
	gc_init();
#endif /*USE_GC*/

#ifdef LDIRECT_INTERVAL
	/* ؑցE16K\܂B */
	ldirect_init(LDIRECT_INTERVAL);
#endif /*LDIRECT_INTERVAL*/

#ifdef USE_MUSIC
	/* yCu܂B */
	music_loudness(1);
	loadInst(); /* uRandomism Zone(http://www8.plala.or.jp/randomism/)v́whFLbgver.2.10xgp */
	InitMusic();
#endif /*USE_MUSIC*/

	/* N[Abv֐o^B */
	atexit(app_exit);

	/* eNX`܂B */
#ifdef TEXTURE_LIST
	{
		typedef const unsigned char TEXTURE_DATA[];
		extern TEXTURE_DATA TEXTURE_LIST;
		texture_table_init(texture_table, sizeof texture_table / sizeof *texture_table, TEXTURE_LIST);
	}
#endif /*TEXTURE_LIST*/

#ifdef USE_SPRITE
	/* ȈՃXvCghCo܂B */
	sprite_init(&render, sprite_table, SPRITE_COUNT, texture_table, TEXTURE_COUNT);
#endif /*USE_SPRITE*/

/*{{AvP[VL̏*/
	srand(pceTimerGetCount());
/*}}AvP[VL̏*/
}

/****************************************************************************
 *	app_exit
 ****************************************************************************/

void
app_exit()
{
#ifdef USE_MUSIC
	/* mɉyt~܂B
	 * TEh̒~̓CupceAppExit()ōsĂ̂ŁA
	 * ł͕Kv܂B
	 */
	StopMusic();
	music_loudness(0);
#endif /*USE_MUSIC*/

#ifdef LDIRECT_INTERVAL
	/* ؑցE16K\܂B */
	ldirect_free();
#endif /*LDIRECT_INTERVAL*/

#ifdef USE_GC
	/* K[x[WRN^[܂B */
	gc_free();
#endif /*USE_GC*/
}

/****************************************************************************
 *	schedule
 ****************************************************************************/

void
schedule()
{
#define PAUSE_FONT	0x80		/* PAUSEtHg         */
//#define PAUSE_COLOR	0x130		/* PAUSEJ[(wip) */
#define PAUSE_COLOR	0x203		/* PAUSEJ[(wip) */
//#define PAUSE_COLOR	0x5f0		/* PAUSEJ[(16KEwip) */
//#define PAUSE_COLOR	0xa0f		/* PAUSEJ[(16KEwip) */
#define PAUSE_STR	"PAUSE"		/* PAUSEbZ[W       */
#define PAUSE_W		(5 * 5 + 2)	/* PAUSEbZ[W̉ */
#define PAUSE_H		(10    + 2)	/* PAUSEbZ[W̏c */
#define PAUSE_X		((DISP_X - PAUSE_W) / 2) /* \ʒu */
#define PAUSE_Y		((DISP_Y - PAUSE_H) / 2) /* \ʒu */

#ifdef QUICK_REPEAT
	static unsigned char rep[8]; /* I[gs[gJE^ */
#endif /*QUICK_REPEAT*/

	int pause, x, y;
	/* PAUSEbZ[Ẅ̃C[Wޔpobt@́A324oCgKvłB
	 * X^bNɎ̂͊댯łAstaticɎ̖̂ʂłB
	 * ŁAPAUSEɂ̂݃q[vmۂ邱Ƃɂ܂B
	 */
	//unsigned char save[PAUSE_H][PAUSE_W];
	unsigned char (*save)[PAUSE_W] = NULL/*x}*/;

	pause = 0;
	for(;;) {
#ifdef V_SCREEN
		{ /* vbuff(c)_def_vbuff()ϊ */
			unsigned char *dst, *src;
			dst = &_def_vbuff[0];     /* ]̉ʂ͍ォ瑖Jn܂ */
			src = &vbuff[DISP_X - 1]; /* ]̏cʂ͉Eォ瑖Jn܂ */
			for(x = DISP_X - 1; x >= 0; x--) {
				for(y = 0; y < DISP_Y; y++) {
					*dst = *src;
					dst += 1;      /* ʂEɑ܂ */
					src += DISP_X; /* cʂɑ܂ */
				}
				                            /* ʂ͊Ɏ̍sֈړĂ܂ */
				src -= DISP_X * DISP_Y + 1; /* cʂ̗̈ԏֈړ܂ */
			}
		}
#endif /*V_SCREEN*/
		pceLCDTrans();		/* ʍXV */
		yield();		/* VXe */
		joy = pcePadGet();	/* pbhԍXV */
#ifdef V_SCREEN
		joy = (joy & ~(PAD_LF | PAD_RI | PAD_UP | PAD_DN | /* cʗp͕ϊ */
			       TRG_LF | TRG_RI | TRG_UP | TRG_DN))
			| (joy & PAD_LF ? PAD_UP : 0)
			| (joy & PAD_RI ? PAD_DN : 0)
			| (joy & PAD_UP ? PAD_RI : 0)
			| (joy & PAD_DN ? PAD_LF : 0)
			| (joy & TRG_LF ? TRG_UP : 0)
			| (joy & TRG_RI ? TRG_DN : 0)
			| (joy & TRG_UP ? TRG_RI : 0)
			| (joy & TRG_DN ? TRG_LF : 0);
#endif /*V_SCREEN*/

		/* PAUSEB */
		if(joy & TRG_START) {
			pause = !pause;	/* PAUSEԐ؂ւ */
			if(pause) {	/* PAUSE IN */
				/* PAUSEbZ[W\̃C[WޔB */
				save = (unsigned char (*)[PAUSE_W])malloc(PAUSE_W * PAUSE_H); /* C[Wޔpobt@m */
				if(save == NULL) DIE();
				for(y = 0; y < PAUSE_H; y++) {
					for(x = 0; x < PAUSE_W; x++) {
						save[y][x] = vbuff[DISP_X * (PAUSE_Y + y) + (PAUSE_X + x)];
					}
				}
			} else {	/* PAUSE OUT */
				/* PAUSEbZ[W\̃C[W𕜋AB */
				for(y = 0; y < PAUSE_H; y++) {
					for(x = 0; x < PAUSE_W; x++) {
						vbuff[DISP_X * (PAUSE_Y + y) + (PAUSE_X + x)] = save[y][x];
					}
				}
				free(save); /* C[Wޔpobt@J */
			}
		}
		if(!pause) break;

		/* PAUSEbZ[W_ŕ\B */
		if(pceTimerGetCount() % 1000 < 750) {
			render_string_framed(&render, PAUSE_X, PAUSE_Y, PAUSE_STR, PAUSE_FONT, PAUSE_COLOR);
		} else {
			for(y = 0; y < PAUSE_H; y++) {
				for(x = 0; x < PAUSE_W; x++) {
					vbuff[DISP_X * (PAUSE_Y + y) + (PAUSE_X + x)] = save[y][x];
				}
			}
		}
	}
	now++;	/* O[o^C}XV */

#ifdef QUICK_REPEAT
	/* I[gs[gB */
	for(x = 0; x < 8; x++) {
		y = 1 << x; /* PAD_* */
		if(QUICK_REPEAT_PADS & y) {
			if(joy & y) {
				if(rep[x] != 0xff) rep[x]++;
				if(rep[x] >= QUICK_REPEAT_DELAY) joy |= y << 8; /* TRG_* */
			} else {
				rep[x] = 0;
			}
		}
	}
#endif QUICK_REPEAT

#undef PAUSE_FONT
#undef PAUSE_COLOR
#undef PAUSE_STR
#undef PAUSE_W
#undef PAUSE_H
#undef PAUSE_X
#undef PAUSE_Y
}

/****************************************************************************
 *	demo_main
 ****************************************************************************/

int
demo_main()
{
	int result = -1;
	int sel = 0; /* 0:ColorNum/1:BossLife */
	//
	int x;
	int y;

	for(;;) {
		schedule();

		/* wi\B*/
		sprite_draw(0, 0, SPR_TITLEBG, 0);

		/* GtFNg\B */
		if(!((unsigned)now % SEC(0.25))) {
			effect_new(ET_TITST, 0, 0);
		}
		effect_action();
		effect_disp(2);

		/* ^Cg\B */
		x = 0;
		y = fist(fadd(fimul(fsin(fidiv(fimul(PI2, now),
			SEC(3)/**/)),
			2/*ꕝ*/), fld(0.5)));
		sprite_draw(x, y, SPR_TITLE, 0);

		/* X^[gHIH */
		if(joy & TRG_A) {
			result = 0;
			break;
		}
		if(joy & TRG_SELECT) {
			result = -1;
			break;
		}

		/* ՓxIB */
		if(joy & TRG_UP) {
			sel = 0;
		}
		if(joy & TRG_DN) {
			sel = 1;
		}
		switch(sel) {
		case 0:
			if((joy & TRG_LF) && (color_num > 1)) color_num--;
			if((joy & TRG_RI) && (color_num < 3)) color_num++;
			break;
		case 1:
			if((joy & TRG_LF) && (boss_life > 3)) boss_life--;
			if((joy & TRG_RI) && (boss_life < 7)) boss_life++;
			break;
		default:
			DIE();
		}

		/* XRA\B */
		x = 4;
		y = 1;
		render_printf_framed(&render, x, y, 0x82, 0x232, "1P %07d", game.score <= 9999999 ? game.score : 9999999);
		render_printf_framed(&render, x, y, 0x82, 0x230, "1P %7d" , game.score <= 9999999 ? game.score : 9999999);
		x = DISP_X - 4 * 10 - 5;
		y = 1;
		render_printf_framed(&render, x, y, 0x82, 0x232, "HI %07d", hiscore <= 9999999 ? hiscore : 9999999);
		render_printf_framed(&render, x, y, 0x82, 0x230, "HI %7d" , hiscore <= 9999999 ? hiscore : 9999999);

		/* vvg\B */
		x = 20;
		y = DISP_Y - 8 * 2;
		render_string_framed(&render, x, y, " A START", 0x82, 0x231);
		y += 8;
		render_string_framed(&render, x, y, "SEL EXIT", 0x82, 0x231);

		/* xI\B */
		x = DISP_X - 4 * 10 - 21;
		y = DISP_Y - 8 * 2;
		render_printf_framed(&render, x, y, 0x82, sel == 0 ? 0x230 : 0x232, "COLORS   %d", color_num);
		y += 8;
		render_printf_framed(&render, x, y, 0x82, sel == 1 ? 0x230 : 0x232, "BOSSLIFE %d", boss_life);
	}

	return result;
}
